from random import *
from pfc_joueur import *

class IAPfc(Joueur) :

    def __init__(self) :
        Joueur.__init__(self)
        self.coups = ['P','F','C']

    def coup_alea(self) :
        #print("je joue au hasard")
        return choice(self.coups)

    def predire(self,np,nf,nc):
        aux = 'F'*np+'C'*nf+'P'*nc
        #print(np,nf,nc,"result",aux)
        predict = aux[randint(0,len(aux)-1)]
        return predict

    def coup_ia(self,history):
        #print("coup ia avec historique="+history)
        if len(history)<=4 : return self.coup_alea()
        nmatch=1
        contextsz = 0
        predictionlist=[]

        while nmatch != 0:
            nmatch=0
            contextsz +=1
            contexte=history[-contextsz:]
            np=nf=nc=0
            
            #print("contexte à rechercher " + contexte)
            for i in range(0,len(history)-contextsz):
                if history[i:i+contextsz] == contexte :
                    nmatch += 1
                    coupsuivant = history[i+contextsz+1]
                    if coupsuivant=='p': np+=1
                    if coupsuivant=='f': nf+=1
                    if coupsuivant=='c': nc+=1
                    
            #print("dans le contexte",contexte," tu as joue: p=",np,"f=",nf,"c=",nc)
            if nmatch>0:
                prediction=self.predire(np,nf,nc)
                predictionlist.append(prediction)
                #print("j'ai envie de jouer", prediction)
            else: break

        #print( "au final " , predictionlist)
        if len(predictionlist)>0:
            return predictionlist[len(predictionlist)-1]
        else: return self.coup_alea()

